<template>
	<div>
<!--		EDIT EVENT TYPES-->
		<div class="cards">
			<h4>Kategorien</h4>
			<div class="card-body">
				<div class="cols c-0-1-0">
					<div class="cell c-merged-2">
						<custom-switch @clicked="globalToggleDeleteButtons" />
						L&ouml;schen
					</div>
					<div class="cell">E</div>
					<template  v-for="eventType in allEventTypes">
						<div :key="'col1-' + eventType.id" class="cell button-row--icons">
							<button ref="delete" @click="deleteEventType(eventType.id)" class="button button--close" disabled></button>
							<button ref="edit" @click="editEventType(eventType.id)" class="button button--edit"></button>
						</div>
						<div :key="'col2-' + eventType.id" class="cell bg-4">{{ eventType.title }}</div>
						<div :key="'col3-' + eventType.id" class="cell text-center" :class="[ eventType.totalEventsOfType ? 'bg-4' : 'bg-t1' ]">{{ eventType.totalEventsOfType }}</div>
					</template>
				</div>
			</div>
			<div class="cell">
				E: Events
			</div>
		</div>

		<loader v-if="isLoading" />

<!--		EDIT EVENT TYPE COMPONENT-->
		<admin-event-types-edit v-if="showEditEventType" :event-type-to-edit="eventTypeToEdit"  />

<!--		ADD EVENT TYPE-->
		<div class="cards" ref="editEventTypeOffset">
			<h4>Hinzuf&uuml;gen</h4>
			<div class="card-body">
				<form v-on:submit.prevent class="cols c-0-1 mobile-flex">
					<div class="cell">Titel</div>
					<div class="cell">
						<input ref="title" v-model="form.title" class="input" type="text" />
					</div>
					<div class="cell c-merged">
						<button type="submit" @click="postEventType" class="button button--mobile-stretch">Speichern</button>
					</div>
				</form>
			</div>
		</div>
		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</div>

</template>

<script>
import SystemMessage from "@/components/SystemMessage";
import AdminEventTypesEdit from "@/components/admin/AdminEventTypesEdit";
import CustomSwitch from "@/components/buttons/CustomSwitch";
import Loader from "@/components/Loader";

export default {
	name: "AdminEventTypes",
	components: {
		Loader,
		CustomSwitch,
		AdminEventTypesEdit,
		SystemMessage
	},
	data: () => ({
		isLoading: false,
		form: {
			title: ""
		},
		showEditEventType: false,
		eventTypeToEdit: {},
		sysMsg: undefined
	}),
	methods: {
		async deleteEventType(id) {
			this.sysMsg = "";
			try {
				const response = await this.$http.delete("/api/admin/eventTypes/delete/" + id);
				switch (response.status) {
					case 200:
						this.sysMsg = "Kategorie erfolgreich gelöscht!";
						await this.$store.dispatch("getAllEventTypes");
						break;

				}
			} catch (e) {
				console.error(e);
			}
		},

		async postEventType() {
			this.sysMsg = "";
			let verified = this.globalValidateForm();
			if (!verified) {
				this.sysMsg = "Fehlende Eingaben!";
				return;
			}

			try {
				const response = await this.$http.post("/api/admin/eventTypes/post", this.form);
				if (response.status === 200) {
					this.globalEmptyForm();
					this.sysMsg = "Kategorie erfolgreich eingetragen!";
					await this.$store.dispatch("getAllEventTypes");
				}
			} catch (e) {
				console.error(e.response);
			}
		},

		editEventType(id) {
			if (this.eventTypeToEdit.id === id) {
				this.showEditEventType = !this.showEditEventType;
			} else {
				this.showEditEventType = true;
			}

			if (this.showEditEventType) {
				window.scrollTo(0, this.$refs.editEventTypeOffset.offsetTop);
			}

			for (let eventType of this.allEventTypes) {
				if (eventType.id === id) {
					this.eventTypeToEdit = eventType;
				}
			}
		}
	},
	computed: {
		allEventTypes() {
			return this.$store.getters.getAllEventTypes;
		}
	},
	mounted() {
		this.isLoading = true;
		this.$store.dispatch("getAllEventTypes").then(() => this.isLoading = false);
	}
}
</script>

<style scoped>

</style>